# -*- coding: utf-8 -*-

from em_tasks import logger
from em_tasks.utils.product_converters import AmzProductConverter


class ShopifyAmzProductFormatter():
  def __init__(self, marketplace, product_service, offer_service, price_caculator):
    self.condition = 'new'
    self.marketplace = marketplace
    self.product_service = product_service
    self.offer_service = offer_service
    self.price_calc = price_caculator
    self.pc = AmzProductConverter(marketplace)
    self.indice_name = 'amz_products_api_{}'.format(marketplace.lower())

  def format_products(self, asins):
    products_info = self.product_service.search_products(self.indice_name, asins)
    if not products_info:
      return

    offers = dict()
    src_offers = self.offer_service.get_offers(self.marketplace, asins, self.condition)
    if not src_offers:
      return

    prods = dict()
    for asin, product_info in products_info.items():
      prod = self.pc.convert(product_info)
      src_offer = src_offers.get(asin, None)
      offer = self.price_calc.calc_offer(src_offer)
      if offer:
        prod['price'] = offer['price']
        prod['quantity'] = offer['quantity']
      else:
        prod['price'] = 0
        prod['quantity'] = 0

      prods[asin] = prod

    return prods
